package com.hchyun.generator.controller;

import java.io.Serializable;
import java.util.List;


import com.hchyun.common.constant.ReturnConstants;
import com.hchyun.common.core.controller.HcyBaseController;
import com.hchyun.common.utils.ServerResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.hchyun.common.annotation.Log;
import com.hchyun.common.core.entity.AjaxResult;
import com.hchyun.common.enums.BusinessType;
import com.hchyun.generator.entity.Module;
import com.hchyun.generator.service.ModuleService;
import com.hchyun.common.utils.poi.ExcelUtil;

/**
 * 模块管理Controller
 * 
 * @author hchyun
 * @date 2021-01-24
 */
@RestController
@RequestMapping("/tool/module")
public class ModuleController extends HcyBaseController {
    protected final Logger logger = LoggerFactory.getLogger(ModuleController.class);

    @Autowired
    private ModuleService moduleService;


    /**
     * 获取到api类的select选项
     * @return
     */
    @PreAuthorize("@ss.hasAnyPermi('tool:module:querylist')")
    @GetMapping("querylist")
    public AjaxResult queryList(){
        try {
            ServerResult<List<Module>> serverResult = moduleService.selectModuleList(new Module());
            if (serverResult.isStart()){
                return AjaxResult.success(serverResult.getData());
            }else {
                return AjaxResult.error(serverResult.getMsg());
            }
        }catch (RuntimeException e){
            logger.error(e.getMessage());
            return AjaxResult.error(ReturnConstants.SYS_ERROR);
        }
    }



    /**
     * 查询模块管理列表
     */
    @PreAuthorize("@ss.hasPermi('tool:module:list')")
    @GetMapping("/list")
    public Serializable list(Module module) {
        try {
            startPage();
            ServerResult<List<Module>> serverResult = moduleService.selectModuleList(module);
            if (serverResult.isStart()) {
                return getDataTable(serverResult.getData());
            } else {
                return AjaxResult.info(serverResult.getMsg());
            }
        } catch (RuntimeException e) {
            logger.error(e.getMessage());
            return AjaxResult.error(ReturnConstants.SYS_ERROR);
        }
    }

    /**
     * 导出模块管理列表
     */
    @PreAuthorize("@ss.hasPermi('tool:module:export')")
    @Log(title = "模块管理", businessType = BusinessType.EXPORT)
    @GetMapping("/export")
    public AjaxResult export(Module module) {
        try {
            ServerResult<List<Module>> serverResult = moduleService.selectModuleList(module);
            ExcelUtil<Module> util = new ExcelUtil<Module>(Module. class);
            if (serverResult.isStart()) {
                return util.exportExcel(serverResult.getData(), "module");
            } else {
                return AjaxResult.error(serverResult.getMsg());
            }
        } catch (RuntimeException e) {
            logger.error(e.getMessage());
            return AjaxResult.error(ReturnConstants.SYS_ERROR);
        }
    }

    /**
     * 获取模块管理详细信息
     */
    @PreAuthorize("@ss.hasPermi('tool:module:query')")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id) {
        try {
            ServerResult<Module> serverResult = moduleService.selectModuleById(id);
            if (serverResult.isStart()) {
                return AjaxResult.success(serverResult.getData());
            } else {
                return AjaxResult.info(serverResult.getMsg());
            }
        } catch (RuntimeException e) {
            logger.error(e.getMessage());
            return AjaxResult.error(ReturnConstants.SYS_ERROR);
        }
    }

    /**
     * 新增模块管理
     */
    @PreAuthorize("@ss.hasPermi('tool:module:add')")
    @Log(title = "模块管理", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody Module module) {
        if (module.getmName() == null || module.getmName().equals("")) {
            return AjaxResult.error("模块名称不能为空!");
        }
        if (module.getmDescribe() == null || module.getmDescribe().equals("")) {
            return AjaxResult.error("模块描述不能为空!");
        }
        try {
            ServerResult<Integer> serverResult = moduleService.insertModule(module);
            if (serverResult.isStart()) {
                return AjaxResult.success();
            } else {
                return AjaxResult.error(serverResult.getMsg());
            }
        } catch (RuntimeException e) {
            logger.error(e.getMessage());
            return AjaxResult.error(ReturnConstants.SYS_ERROR);
        }
    }

    /**
     * 修改模块管理
     */
    @PreAuthorize("@ss.hasPermi('tool:module:edit')")
    @Log(title = "模块管理", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody Module module) {
        try {

            if (module.getmName() == null || module.getmName().equals("")) {
                return AjaxResult.error("模块名称不能为空!");
            }
            if (module.getmDescribe() == null || module.getmDescribe().equals("")) {
                return AjaxResult.error("模块描述不能为空!");
            }
            ServerResult<Integer> serverResult = moduleService.updateModule(module);
            if (serverResult.isStart()) {
                return AjaxResult.success();
            } else {
                return AjaxResult.error(serverResult.getMsg());
            }
        } catch (RuntimeException e) {
            logger.error(e.getMessage());
            return AjaxResult.error(ReturnConstants.SYS_ERROR);
        }
    }

    /**
     * 删除模块管理
     */
    @PreAuthorize("@ss.hasPermi('tool:module:remove')")
    @Log(title = "模块管理", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids) {
        try {
            if (ids.length<0){
                return AjaxResult.error("id不能为空!");
            }
            ServerResult<Integer> serverResult = moduleService.deleteModuleByIds(ids);
            if (serverResult.isStart()) {
                return AjaxResult.success();
            } else {
                return AjaxResult.error(serverResult.getMsg());
            }
        }catch (RuntimeException e){
            logger.error(e.getMessage());
            return AjaxResult.error(ReturnConstants.SYS_ERROR);
        }
    }
}
